-- File name   : TDRA.MS
-- Title       : TD/RA tools
-- Category    : not implemented yet
-- Environment : 3ds max 3&4, GMAX
-- Description : toolset for TD/RA SHP building
-- Reference   :
-- Copyright (c) 2002 by Flyby, 2008 by raminator, 2010 by KatzSmile
-- VERSION		: 0.04

initial_state = #()
global_counter = 0

rollout SETUPTOOLS "TD/RA SHP TOOLS" 
(
group "Ground Plane"
	(
	button do_shdwmatte " Create Ground Plane" width:150 height:25 align:#centre
	)
group "Camera Tools"
	(
	radiobuttons S_W_N_E labels:#("South","North","West","East") columns:4 align:#centre height:20
	button do_cam " Create Camera " width:150 height:25 align:#centre
		)
group "Light Tools"
	(
	button do_shadow_lite " Create shadow light " width:150 height:25 align:#centre
	)

group "Animation"
	(
    button do_frames_set "Animation 32 frames >" width:150 height:25 align:#centre
	)
	
on do_frames_set pressed do
(
Box lengthsegs:1 widthsegs:1 heightsegs:1 length:15 width:15 height:15 mapCoords:on pos:[0,0,0] isSelected:on
$.xray = on
$.renderable = off

set animate on
sliderTime += 1 
rotate $ (angleaxis 11.25 [0,0,1]) --1
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --2
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --3
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --4
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --5
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --6
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --7
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --8
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --9
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --10
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --11
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --12
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --13
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --14
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --15
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --16
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --17
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --18 
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --19
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --20
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --21
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --22
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --23
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --24 
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --25
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --26
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --27
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --28
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --29
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --30
sliderTime += 1
rotate $ (angleaxis 11.25 [0,0,1]) --31
set animate off 


clearSelection()


)

on do_shadow_lite pressed do
(
		litepos1 = case S_W_N_E.state of
			(
				1:[-100,50,400] 
				2:[100,-50,400]
				3:[50,100,400]
				4:[-50,-100,400]
			)
		litepos2 = case S_W_N_E.state of
			(
				1:[0,-141.5,81.65] 
				2:[0,141.5,81.65]
				3:[-141.5,0,81.65]
				4:[141.5,0,81.65]
			)
targetSpot name:"ShadowCaster" raytracedShadows:true castShadows:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos1 rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.8 contrast:50 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:1 hotspot:100 falloff:110 aspect:1
targetSpot name:"LightCaster" raytracedShadows:false castShadows:off target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) pos:litepos2 rgb:(color 255 255 255) shadowColor:(color 0 0 0) multiplier:.6 contrast:50 softenDiffuseEdge:50 nearAttenStart:0 nearAttenEnd:40 farAttenStart:80 farAttenEnd:200 decayRadius:40 atmosOpacity:100 atmosColorAmt:100 shadowMultiplier:1 hotspot:100 falloff:110 aspect:1 excludeList:#($Shadowplane) 
)

on do_shdwmatte pressed do
(
try (delete $ShadowPlane) catch ()
plane length:1000 width:1000 name:"ShadowPlane" gbufferChannel:13 setBackGround [0,0,0]
$ShadowPlane.material= matteShadow() 
$ShadowPlane.material.color = color  84 252 84
$ShadowPlane.material.receiveShadows = true

)
on do_cam pressed do
	(
		try
		(	
			delete $lights
			delete $camera01
		)
		catch()

		viewport.ResetAllViews ()
		camd= case S_W_N_E.state of
			(
				1:[0,-135.22,120.5]
				2:[0,135.22,120.5]
				3:[-135.22,0,120.5]
				4:[135.22,0,120.5]
			)

		cam=Targetcamera  pos:camd isSelected:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,28.8]))
		cam.fov = 65.47
		cam.orthoProjection=true
		viewport.activeViewport = 4
		viewport.setCamera cam
	)

 on camdist changed val do
	(
		try
		(
			camd= case S_W_N_E.state of
			(
				1:[0,-135.22,120.5]
				2:[0,135.22,120.5]
				3:[135.22,0,120.5]
				4:[135.22,0,120.5]
			)
			$Camera01.pos = camd
		)
		catch (messageBox "Life would be much better if you first make a CAMERA, don't you agree ...?")
	)
)


rollout WHO_ "About" 
(
	label l1 "TD/RA SHP TOOLS"
	label l2 "Version 0.01"
	label l3 "by raminator"
)

if FloaterExampleFloater != undefined do
				(
				closerolloutfloater FloaterExampleFloater
				)		
FloaterExampleFloater = newRolloutFloater "TD/RA TOOLSET" 250 314 
addRollout SETUPTOOLS FloaterExampleFloater
addRollout WHO_ FloaterExampleFloater


